/* This file is autogenerated by scripts/decodetree.py.  */

typedef struct {
    int rs;
    int rt;
    int rd;
    int sa;
} arg_r;

typedef arg_r arg_CPUCFG;
static bool trans_CPUCFG(DisasContext *ctx, arg_CPUCFG *a);
typedef arg_r arg_RDCSR;
static bool trans_RDCSR(DisasContext *ctx, arg_RDCSR *a);
typedef arg_r arg_WRCSR;
static bool trans_WRCSR(DisasContext *ctx, arg_WRCSR *a);
typedef arg_r arg_DRDCSR;
static bool trans_DRDCSR(DisasContext *ctx, arg_DRDCSR *a);
typedef arg_r arg_DWRCSR;
static bool trans_DWRCSR(DisasContext *ctx, arg_DWRCSR *a);

static void decode_ase_lcsr_extract_rs_rd(DisasContext *ctx, arg_r *a, uint32_t insn)
{
    a->rd = extract32(insn, 11, 5);
    a->rt = 0;
    a->rs = extract32(insn, 21, 5);
    a->sa = 0;
}

bool decode_ase_lcsr(DisasContext *ctx, uint32_t insn)
{
    union {
        arg_r f_r;
    } u;

    decode_ase_lcsr_extract_rs_rd(ctx, &u.f_r, insn);
    switch (insn & 0xfc1f07ffu) {
    case 0xc8000118u:
        /* 110010.. ...00000 .....001 00011000 */
        /* ../target/mips/tcg/lcsr.decode:14 */
        if (trans_RDCSR(ctx, &u.f_r)) return true;
        break;
    case 0xc8010118u:
        /* 110010.. ...00001 .....001 00011000 */
        /* ../target/mips/tcg/lcsr.decode:15 */
        if (trans_WRCSR(ctx, &u.f_r)) return true;
        break;
    case 0xc8020118u:
        /* 110010.. ...00010 .....001 00011000 */
        /* ../target/mips/tcg/lcsr.decode:16 */
        if (trans_DRDCSR(ctx, &u.f_r)) return true;
        break;
    case 0xc8030118u:
        /* 110010.. ...00011 .....001 00011000 */
        /* ../target/mips/tcg/lcsr.decode:17 */
        if (trans_DWRCSR(ctx, &u.f_r)) return true;
        break;
    case 0xc8080118u:
        /* 110010.. ...01000 .....001 00011000 */
        /* ../target/mips/tcg/lcsr.decode:12 */
        if (trans_CPUCFG(ctx, &u.f_r)) return true;
        break;
    }
    return false;
}
